<?php

namespace Ecommerce\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;

class ContasAReceberTek extends \Teknisa\Libs\Controller\CRUD
{

    protected $dataSourceManager;
    protected $crudService;
    protected $parameterBag;
    protected $parameterBagColumns = array();
    public $titulo;

    public function __construct($crudService, $parameterBag, $dataSourceManager)
    {
        $this->dataSourceManager = $dataSourceManager;
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
    }

    public function retornaContas(DTO\Request\Filter $request, DTO\Response $response)
    {
        try {
            $filterCriteria = $request->getFilterCriteria();
    
            foreach ($filterCriteria->getConditions() as $i) {
    
                if ($i['columnName'] != 'P_TITULO') {
                    $parameterBagColumns[] = $i['columnName'];
                } else {
                    $titulo = $i['value'];
                }
    
            }
    
            $consultaCR = array(
                'SQ' => 'crsemquitacao',
                'Q' => 'crquitado',
                'EA' => 'crematraso',
                'PE' => 'crporemissao',
                'EB' => 'crenviadosaobanco',
            );
    
            $this->dataSourceName = $consultaCR[$titulo];
            $this->parameterBagColumns = $parameterBagColumns;
    
            $dataSet = $this->find($request, $response);
    
            $response->addDataSet(new DataSet ('contasAReceberTek', $dataSet));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }

    }

    public function find(DTO\Request\Filter $request, DTO\Response $response)
    {

        $filterCriteria = $request->getFilterCriteria();

        $cdforneced = $filterCriteria->getConditions()[0]['value'];
        $dtinicial = $filterCriteria->getConditions()[1]['value'];
        $dtfinal = $filterCriteria->getConditions()[2]['value'];
        $lancamento = $filterCriteria->getConditions()[4]['value'];
        $nrorg = $filterCriteria->getConditions()[5]['value'];
        if(isset($filterCriteria->getConditions()[6])) {
            $name = $filterCriteria->getConditions()[6]['columnName'];
            $operator = $filterCriteria->getConditions()[6]['operator'];
            $filter = $filterCriteria->getConditions()[6]['value'];
        }

        $filterCriteria = new FilterCriteria($this->dataSourceName);

        $filterCriteria->addCondition('P_CDFORNECED', $cdforneced);
        $filterCriteria->addCondition('P_DTINICIAL', $dtinicial);
        $filterCriteria->addCondition('P_DTFINAL', $dtfinal);
        $filterCriteria->addCondition('P_LANCAMENTO', $lancamento);
        $filterCriteria->addCondition('NRORG', $nrorg);

        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        
        if(isset($operator) && $operator == "LIKE_ALL") {
            $newFilterCriteria->addCondition($name, $operator, $filter);
        }
        
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);

        return $dataSet->getRows();

    }

}