var ContasAReceberController = function(ScreenService, ContasAReceberService, localStorageEngine, ZhFilterPreferences, PadraoExibicao, General, metaDataFactory, ZhUtil, maskEngine, Utilities, templateManager){

	this.removeContainer = function() {
        let name = "product#ContasAReceber";
        if(templateManager.containers[name]) {
        	delete templateManager.containers[name];
        }
    };

	this.openDefaultFilter = function(widget) {
		var filterRow = {
            NMFANTFORN: [getLocalVar('CDFORNECED')],
            STATUS: "T",
            IDCONTAANTECIPADA : "T"
        };
        
        Utilities.startFilter(widget, filterRow);
        
        // para não perder o valor default quando fecha o filtro sem aplicar;
        // ZhFilterPreferences.createFilterWidget(widget, filterRow).then(function() {
        // 	ZhFilterPreferences.openFilterWidget(widget);
        // }); 
	};

	this.backOrCancel = function(widget){
		ScreenService.closeSwipe();
		widget.container.getWidget('gridWidget').activate();
	};
	
	this.totalizaValor = function(widget){
		let mascara = {
                        "type": "float",
                        "params": {
                            "symbol": "",
                            "precision": 2,
                            "thousands": ".",
                            "decimal": ","
                        }
                    };
		let dataSet = widget.dataSource.data;
		let valorTotal = 0 ;
		for(let i = 0; i<dataSet.length; i ++){
			valorTotal += dataSet[i].VRATUAPAG;
		}
		valorTotal = Util.applyMask(valorTotal, mascara, maskEngine, ZhUtil);
		widget.container.getWidget('STRIPE_FILTER').getField('VALORTOTAL').setValue(valorTotal);
		widget.container.getWidget('STRIPE_FILTER').getField('VALORTOTAL').reload();
	};
	
	this.totalizaValorGR = function(widget){
		let mascara = {
                        "type": "float",
                        "params": {
                            "symbol": "",
                            "precision": 2,
                            "thousands": ".",
                            "decimal": ","
                        }
                    };
		let dataSet = widget.dataSource.data;
		let valorTotal = 0 ;
		for(let i = 0; i < dataSet.length; i ++){
			valorTotal += parseFloat(dataSet[i].VRPAGO);
		}
		valorTotal = Util.applyMask(valorTotal, mascara, maskEngine, ZhUtil);
		widget.container.getWidget('stripeWidget').getField('VALORTOTAL').setValue(valorTotal);
		widget.container.getWidget('stripeWidget').getField('VALORTOTAL').reload();
	};

    //USADA PARA DEFINIR TELA PARA GR
    this.defineWindow = function(){
        ContasAReceberService.retornaParamgeral().then(function(callback){
            var idsisdos = callback.dataset.paramgeral[0].IDSISDOS;

            if(idsisdos === 3){
                ScreenService.openWindow("ContasAReceber");
            } else{
                ScreenService.openWindow("ContasAReceberTek");
            }
        });
    };

	this.ultimoPeriodo = function(days) {
		return {
			start: moment().add(days, 'days').format('DD/MM/YYYY'),
			end: moment().format('DD/MM/YYYY')
		};
	};

	this.proximoPeriodo = function(days) {
		return {
			start: moment().format('DD/MM/YYYY'),
			end: moment().add(days, 'days').format('DD/MM/YYYY')
		};
	};

	this.removeValidations = function(widget) {
	    let currentRowWidget = widget.currentRow;
	    const fieldDataPagamento = widget.getField('DTPAGAMENTO');
	    const fieldDataVencimento = widget.getField('DTVENCIMENTO');
	    const fieldNotaFiscal = widget.getField('NF');
	    const completeInterval = { "completeInterval": true };
	    const requiredInterval = { "requiredInterval": true };
	     
		if(this.verificaData(currentRowWidget.DTPAGAMENTO) || this.verificaData(currentRowWidget.DTVENCIMENTO) || currentRowWidget.NF) {
			fieldDataPagamento.validations = completeInterval;
			fieldDataVencimento.validations = completeInterval;
			delete fieldNotaFiscal.validations;
		} else {
			fieldDataPagamento.validations = requiredInterval;
			fieldDataVencimento.validations = requiredInterval;
			fieldNotaFiscal.validations = {"required": true};
		}
	    templateManager.updateTemplate();
	};
	
	this.verificaData = function(data) {
		if(data.start && data.end) {
			return true;
		}
		return false;
	};
	
	this.limpaField = function(args, field) {
		var filterRow =  args.row;
		if(field.value() == "") {
			filterRow.CDEMPRESA = "";
			filterRow.NMEMPRESA = "";
		}
	};

	this.filtro = function(args) {
		const filterRow =  args.e.preference.FILTER_ROW;
		const dtInicialVenc = filterRow.DTVENCIMENTO.start ? filterRow.DTVENCIMENTO.start : "";
		const dtFinalVenc = filterRow.DTVENCIMENTO.end ? filterRow.DTVENCIMENTO.end : "";
		const tDtVenc = !dtInicialVenc && !dtFinalVenc ? 'T': "";
		const dtInicialPag = filterRow.DTPAGAMENTO.start ? filterRow.DTPAGAMENTO.start : "";
		const dtFinalPag = filterRow.DTPAGAMENTO.end ? filterRow.DTPAGAMENTO.end : "";
		const tDtPaga = !dtInicialPag && !dtFinalPag ? 'T': "";
		const nf = filterRow.NF ? filterRow.NF : 'T';
		const cdEmpresa = filterRow.CDEMPRESA ? filterRow.CDEMPRESA : 'T';
		const cdForneced = !filterRow.NMFANTFORN || filterRow.NMFANTFORN.length == 0 ? 'T' : filterRow.NMFANTFORN.join("_");
		
		args.e.preference.CUSTOM_FILTER_ROW  = {};
		
		args.owner.dataSourceFilter = [
				{
                    "name": "P_CDFORNECED",
                    "operator": "=",
                    "value": cdForneced
	            },
	            {
                    "name": "P_DTINICIAL",
                    "operator": "=",
                    "value": dtInicialVenc
                },
                {
                    "name": "P_DTFINAL",
                    "operator": "=",
                    "value": dtFinalVenc
                },
                {
                    "name": "P_TDTVENC",
                    "operator": "=",
                    "value": tDtVenc
                },
                {
                    "name": "P_DTPAGINI",
                    "operator": "=",
                    "value": dtInicialPag
                },
                {
                    "name": "P_DTPAGFIN",
                    "operator": "=",
                    "value": dtFinalPag
                },
                {
                    "name": "P_TDTPAGA",
                    "operator": "=",
                    "value": tDtPaga
                },
                {
                    "name": "P_DSLOGINECO",
                    "operator": "=",
                    "value": getLocalVar('DSLOGINECO'),
                },
                {
                    "name": "NF",
                    "operator": "=",
                    "value": nf
                },
                {
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": cdEmpresa
                },
                {
                    "name": "STATUS",
                    "operator": "=",
                    "value": filterRow.STATUS
                },
                {
                    "name": "ANTECIPADA",
                    "operator": "=",
                    "value": filterRow.IDCONTAANTECIPADA
                }
			];
	};
	
	this.setStripe = function(args) {
		let widgetStripe = args.owner.container.getWidget('stripeWidget');
		let row = args.owner.appliedFilter.FILTER_ROW;
        let dtVencimento = row.DTVENCIMENTO.start ? ScreenService.i18n("De ") + row.DTVENCIMENTO.start  + ScreenService.i18n(" até ") + row.DTVENCIMENTO.end : 'De __/__/___ até __/__/___' ;
        let dtPagamento = row.DTPAGAMENTO.start ? ScreenService.i18n("De ") + row.DTPAGAMENTO.start  + ScreenService.i18n(" até ") + row.DTPAGAMENTO.end : 'De __/__/___ até __/__/___';
        let empresa = row.NMEMPRESA ? row.NMEMPRESA : ScreenService.i18n("Todas");
        let status = row.STATUS == 'T' ? ScreenService.i18n("Todos") : row.STATUS;
        let nf = row.NF ? row.NF : ScreenService.i18n("Todas");
        widgetStripe.currentRow.DTVENCIMENTO = dtVencimento;
    	widgetStripe.currentRow.DTPAGAMENTO = dtPagamento;
    	widgetStripe.currentRow.NMEMPRESA = empresa;
    	widgetStripe.currentRow.NF = nf;
    	widgetStripe.currentRow.STATUS = status;
    	
    	this.setFilterInfo(widgetStripe, args);
    };

	this.cancel = function(gridWidget) {
		ScreenService.closePopup(true);
		gridWidget.activate();
	};

	this.setFilterInfo = function(widgetStripe, args) {
		let stripeRow = widgetStripe.container.getWidget('stripeWidget').currentRow;
		let row = args.owner.appliedFilter.FILTER_ROW;
		let antecipada;
		switch(row.IDCONTAANTECIPADA){
            case 'T':
                antecipada = ScreenService.i18n("Todos");
                break;
            case 'S':
                antecipada = ScreenService.i18n("Sim");
                break;
            case 'N':
                antecipada = ScreenService.i18n("Não");
                break;
        }
		let filterInfo = [];
		filterInfo = [
				{"label": ScreenService.i18n("Previsão de Pagamento"), "value": stripeRow.DTVENCIMENTO},
				{"label": ScreenService.i18n("Data de Pagamento"), "value": stripeRow.DTPAGAMENTO},
				{"label": ScreenService.i18n("Status"), "value": stripeRow.STATUS},
				{"label": ScreenService.i18n("Antecipada"), "value": antecipada},
				{"label": ScreenService.i18n("Nota Fiscal"), "value": stripeRow.NF},
				{"label": ScreenService.i18n("Empresa"), "value":  stripeRow.NMEMPRESA}
			];
		args.owner._filterInfo = filterInfo;
    };
    
	this.detalhesContasAReceber = function(dadosAdicionais){

		let row = dadosAdicionais.parent.currentRow;
		dadosAdicionais.currentRow = row;
		dadosAdicionais.currentRow.NRINSJURFORN = getLocalVar('NRINSJURFORN');
		ScreenService.openSwipe(dadosAdicionais);

	};

	this.filtroCR = function(gridWidget, currentRow){
		if (gridWidget.container.getWidget('formPopupWidget').isValid()) {
			let dtini = currentRow.INTERVALO_DATA.start;
			let dtfin = currentRow.INTERVALO_DATA.end;
			let titulo = currentRow.titulo;
			let lanc = currentRow.lancamento;

            gridWidget.dataSourceFilter = [
                {
                    "name": "P_CDFORNECED",
                    "operator": "=",
                    "value": getLocalVar('CDFORNECED')
                },
                {
                    "name": "P_DTINICIAL",
                    "operator": "=",
                    "value": dtini
                },
                {
                    "name": "P_DTFINAL",
                    "operator": "=",
                    "value": dtfin
                },
                {
                    "name": "P_TITULO",
                    "operator": "=",
                    "value": titulo
                },
                {
                    "name": "P_LANCAMENTO",
                    "operator": "=",
                    "value": lanc
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar('NRORGTRAB')
                }
            ];

            ScreenService.closePopup();
            gridWidget.reload();
            gridWidget.activate();
            this.setStripeData(gridWidget);
		}
	};

	this.abrirFiltroCRTek = function(WidgetfiltroContas){

		ScreenService.openPopup(WidgetfiltroContas);
		if (WidgetfiltroContas.parent.dataSourceFilter.length === 0) {
			WidgetfiltroContas.newRow();
			WidgetfiltroContas.reload();
		}
	};
	
	this.setStripeData = function(widget) {
        let titulos = {
			SQ: ScreenService.i18n("Sem Quitação"),
			Q: ScreenService.i18n("Quitados"),
			EA: ScreenService.i18n("Em atraso"),
			PE: ScreenService.i18n("Por Emissão"),
			EB: ScreenService.i18n("Enviados ao Banco")
        };
        let stripeFilter = widget.container.getWidget('STRIPE_FILTER');
        let filterRow = widget.container.getWidget('formPopupWidget').currentRow;
        stripeFilter.getField('PERIODO').value('De ' + filterRow.INTERVALO_DATA.start +  ' a ' + filterRow.INTERVALO_DATA.end);
        stripeFilter.getField('TITULO').value(titulos[filterRow.titulo]);
        stripeFilter.getField('LANCAMENTO').value(filterRow.lancamento);
    	stripeFilter.getField('LANCAMENTO').isVisible = stripeFilter.getField('LANCAMENTO').value() !== '';
	};
	
	this.limpaTela = function(widget) {
		widget.dataSource.data = [];
		widget.container.getWidget('STRIPE_FILTER').getField('PERIODO').value("");
		widget.container.getWidget('STRIPE_FILTER').getField('TITULO').value("");
		widget.container.getWidget('STRIPE_FILTER').getField('LANCAMENTO').value("");
        let filtro = widget.container.getWidget('formPopupWidget');
 
        filtro.currentRow.lancamento = "";
        filtro.currentRow.titulo = 0;
        
		this.abrirFiltroCRTek(filtro);
	};
	
	this.reportConfig = function (args) {
		let widget = templateManager.container.getWidget('gridWidget');
		let filter = [];
		if(widget.appliedFilter){
			let filterRow = widget.appliedFilter.FILTER_ROW;
			let dtVencimento = filterRow.DTVENCIMENTO.start ? ScreenService.i18n("De ") + filterRow.DTVENCIMENTO.start + ScreenService.i18n(" até ") + filterRow.DTVENCIMENTO.end : "";
			let dtPagamento = filterRow.DTPAGAMENTO.start ? ScreenService.i18n("De ") + filterRow.DTPAGAMENTO.start + ScreenService.i18n(" até ") + filterRow.DTPAGAMENTO.end : "";
			let nf = filterRow.NF ? filterRow.NF : "";
			let empresa = filterRow.NMEMPRESA ? filterRow.NMEMPRESA : "";
			filter = [
				{
					label: ScreenService.i18n("Data de Vencimento"), 
					value: dtVencimento 
				},
				{
					label: ScreenService.i18n("Data de Pagamento"), 
					value: dtPagamento
				},
				{
					label: ScreenService.i18n("Nota Fiscal"), 
					value: nf
				},
				{
					label: ScreenService.i18n("Empresa"), 
					value: empresa
				}
			];	
		}
		
		args.e.metadata.filter = filter;	
	};
	
	this.detalhes = function(widget){
		const popUpDetalhes = templateManager.container.getWidget('detalhes');
		popUpDetalhes.dataSourceFilter = [
                {
                    "name": "CDUNICOSAP",
                    "operator": "=",
                    "value": widget.currentRow.CDUNICOSAP
                },
                {
                	"name": "NRORG",
                    "operator": "=",
                    "value": widget.currentRow.NRORG
                }
		];
		ScreenService.openPopup(popUpDetalhes);
		popUpDetalhes.reload();
		
	};
	
	this.montaRowReport = function(filterRow){
		let dtVencIni = filterRow.DTVENCIMENTO  && filterRow.DTVENCIMENTO.start ? filterRow.DTVENCIMENTO.start : ' ';
		let dtVencFin = filterRow.DTVENCIMENTO  && filterRow.DTVENCIMENTO.end ? filterRow.DTVENCIMENTO.end : ' ';
		let dtPagIni = filterRow.DTPAGAMENTO  && filterRow.DTPAGAMENTO.start ? filterRow.DTPAGAMENTO.start : ' ';
		let dtPagFin = filterRow.DTPAGAMENTO  && filterRow.DTPAGAMENTO.end ? filterRow.DTPAGAMENTO.end : ' ';
		let tdtVenc = dtVencIni != ' ' && dtVencFin != ' ' ? ' ' : 'T';
		let tdtPag = dtPagIni != ' ' && dtPagFin != ' ' ? ' ' : 'T';
		let cdEmpresa = filterRow.CDEMPRESA && filterRow.CDEMPRESA != ' ' ? filterRow.CDEMPRESA : 'T';
		let nf = filterRow.NF && filterRow.NF != ' ' ? filterRow.NF : 'T';
		let cdForneced = filterRow.NMFANTFORN && filterRow.NMFANTFORN.length ? filterRow.NMFANTFORN.join("_") : 'T';
		let cdFornerelacAF = filterRow.CDFORNERELACAF && filterRow.CDFORNERELACAF.length ? filterRow.CDFORNERELACAF.join("_") : 'T';
		
		if(filterRow.REPORT_NAME === 'ECO00103'){
			cdForneced = getLocalVar('CDFORNECED');
		}
		
		let reportRow = {
			P_CDFORNECED	  : cdForneced,
			P_CDFORNERELACAF  : cdFornerelacAF,
			P_TDTVENC		  : tdtVenc,
		    P_DTINICIAL		  : dtVencIni,
			P_DTFINAL		  : dtVencFin,
			P_TDTPAGA   	  : tdtPag,
			P_DTPAGINI 		  : dtPagIni,
			P_DTPAGFIN 		  : dtPagFin,
			NF				  : nf,
			CDEMPRESA   	  : cdEmpresa,
			STATUS 	    	  : filterRow.STATUS,
			P_DSLOGINECO	  : getLocalVar('DSLOGINECO'),
			ANTECIPADA		  : filterRow.IDCONTAANTECIPADA,
			REPORT_NAME 	  : filterRow.REPORT_NAME
		};
		return reportRow;
	};
	
	this.openReport = function(widget, gridWidget){	
		let filterRow = gridWidget.appliedFilter.FILTER_ROW;
		filterRow.REPORT_NAME = widget.currentRow.REPORT_NAME;
		
		if(filterRow.REPORT_NAME === 'ECO00103'){
			filterRow.CDFORNERELACAF = widget.currentRow.CDFORNERELACAF;
		}
		let reportRow = this.montaRowReport(filterRow);
		
		if(filterRow.REPORT_NAME === 'ECO00100' || filterRow.REPORT_NAME === 'ECO00103'){
			var reportFormats = [
			    {
			        name: "pdf",
			        value: "PDF"
			    },
			    {
			        name: "xlsx",
			        value: "XLSX"
			    },
			    {
			        name: "txt",
			        value: "TXT"
			    }
			];
			General.openReportPopup(gridWidget, this.generateReport, [filterRow, reportRow, gridWidget], reportFormats);
		} else {
			this.generateReport(filterRow, reportRow, gridWidget);
		}
	};
	 
	this.generateReport = function(widgetRow, reportRow, gridWidget) {
		const informedType = reportRow.REPORT_NAME === 'ECO00100' || reportRow.REPORT_NAME === 'ECO00103';
		
		reportRow.QR2TYPE = informedType ? gridWidget.container.getActiveWidget('reportWidget').currentRow.QR2TYPE : "XLSX";
		General.openReport('product#/contas_receber_relatorio', reportRow.REPORT_NAME, reportRow);
	};
	
	this.setPropertyWidget = function(){
		templateManager.container.getActiveWidget().openSwipeDetalhesDif = true;
	};
	
	 this.openSwipeDetalhesDif = function(widget){
	 	if(widget.openSwipeDetalhesDif && (General.valueToFloat(widget.currentRow.VRDIFAFNF) > 0)){
	 		let widgetDetalheDiferenca = widget.container.getWidget('detalhamentoDiferenca');
	 		ScreenService.openSwipe(widgetDetalheDiferenca);
			widgetDetalheDiferenca.dataSourceFilter = [
	                {
	                    "name": "NRNOTAFISCAL",
	                    "operator": "=",
	                    "value": widget.currentRow.NRNOTAFISCAL
	                },
	                {
	                    "name": "CDFORNECEDOR",
	                    "operator": "=",
	                    "value": widget.currentRow.CDFORNECEDOR
	                },
	                {
	                	"name": "NRORG",
	                    "operator": "=",
	                    "value": widget.currentRow.NRORG
	                }
				];
			widgetDetalheDiferenca.reload();
			widget.openSwipeDetalhesDif = false;
		}else{
			widget.openSwipeDetalhesDif = false;
		}
	 };
	 
	 this.exibeFornecedorRelacionado = function(widget){
	 	if(widget.currentRow.REPORT_NAME === "ECO00103"){
	 		widget.getField("CDFORNERELACAF").isVisible = true;
	 		widget.reload();
	 	}else{
	 		widget.reload().then(function(response){
	 			widget.getField("CDFORNERELACAF").isVisible = false;
	 			widget.currentRow.CDFORNERELACAF = {};
	 			widget.currentRow.CDFORNECED2 = {};
	 			widget.currentRow.NMFANTFORN2 = {};
	 		});
	 	}
	 };
};

Configuration(function(ContextRegister) {
	ContextRegister.register('ContasAReceberController', ContasAReceberController);
});